m4_divert(-1)                                                       -*- C -*-

# Yacc-compatible skeleton for Bison, Java version
# Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002, 2003, 2004, 2005
# Free Software Foundation, Inc.

# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.

# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
# 02111-1307  USA

m4_include(b4_pkgdatadir/[c.m4])

## ---------------- ##
## Default values.  ##
## ---------------- ##

# Stack parameters.
m4_define_default([b4_stack_depth_max], [10000])
m4_define_default([b4_stack_depth_init],  [200])


## ------------ ##
## Data Types.  ##
## ------------ ##

# b4_int_type(MIN, MAX)
# ---------------------
# Return the smallest int type able to handle numbers ranging from
# MIN to MAX (included).  We overwrite the version from c.m4 which relies
# on "signed char" which is not portable to old K&R compilers.
m4_define([b4_int_type],
[m4_if(b4_ints_in($@,      [0],   [255]), [1], [short],
       b4_ints_in($@,   [-128],   [127]), [1], [short],

       b4_ints_in($@,      [0], [65535]), [1], [char],
       b4_ints_in($@, [-32768], [32767]), [1], [short],

       m4_eval([0 <= $1]),                [1], [int],

 	                                       [int])])


## ----------------- ##
## Semantic Values.  ##
## ----------------- ##


# b4_lhs_value([TYPE])
# --------------------
# Expansion of $<TYPE>$.
m4_define([b4_lhs_value],[yyval])

# b4_rhs_value(RULE-LENGTH, NUM, [TYPE])
# --------------------------------------
# Expansion of $<TYPE>NUM, where the current rule has RULE-LENGTH
# symbols on RHS.
m4_define([b4_rhs_value],
[(m4_ifval([$3],[($3)])yyvsa@{yyvsp+(m4_eval([$2 - $1]))@})])

## ----------- ##
## Synclines.  ##
## ----------- ##


# b4_syncline(LINE, FILE)
# -----------------------
m4_define([b4_syncline],
[m4_if(b4_synclines_flag, 1,
       [// _line_ $1 $2])])


## ----------- ##
## Locations.  ##
## ----------- ##

# b4_lhs_location()
# -----------------
# Expansion of @$.
m4_define([b4_lhs_location],
[(yyloc)])


# b4_rhs_location(RULE-LENGTH, NUM)
# ---------------------------------
# Expansion of @NUM, where the current rule has RULE-LENGTH symbols
# on RHS.
m4_define([b4_rhs_location],
[(yylsa@{yylsp+(m4_eval([$2 - $1]))@})])

## --------------------------------------------------------- ##
## Token definitions.					     ##
## --------------------------------------------------------- ##

m4_define([b4_token_defines],
[m4_if([$@], [[]], [],
[/* Tokens.  */
   YY_API_ACCESS static final int
m4_map_sep([     b4_token_enum], [,
],
           [$@]);])])


# We do want M4 expansion after # for CPP macros.
m4_changecom()
m4_divert(0)dnl
@output @output_parser_name@
b4_copyright([Skeleton parser for Yacc-like parsing with Bison, Java version],
             [1984, 1989, 1990, 2000, 2001, 2002, 2003, 2004, 2005])[

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

/* Written by Richard Stallman by simplifying the original so called
   ``semantic'' parser.  Adopted for Java by P. N. Hilfinger */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

]b4_identification[

#define YY_API_ACCESS %APIACCESS%

%HEADER% 
{

]b4_token_defines(b4_tokens)[

/* Copy the first part of user declarations.  */
]b4_pre_prologue[
/* End first part of user declarations.  */

#define YYSTYPE %SEMANTIC%

#ifndef YYLTYPE
]b4_locations_if([
# define YYLTYPE Location

  YY_API_ACCESS static class Location {
    public Location (int first_line, int first_column, 
	   	     int last_line, int last_column) {
      set (first_line, first_column, last_line, last_column);
    } 
    public Location (int line, int column) {
      set (line, column);
    } 
    public void set (int first_line, int first_column, 
	   	     int last_line, int last_column) {
      this.first_line = first_line; this.first_column = first_column;
      this.last_line = last_line; this.last_column = last_column;
    } 
    public void set (int line, int column) {
      first_line = last_line = line; 
      first_column = last_column = column;
    } 
    public int first_line;
    public int first_column;
    public int last_line;
    public int last_column;
    public static Location location_range (Location L0, 
					   Location L1, Location L2) {
      if (L1 == null || L2 == null)
	return null;
      return new Location (L1.first_line, L1.first_column,
			   L2.first_line, L2.first_column);
    }
    public static Location location_range (Location L0, Location L1) {
      if (L1 == null)
	return null;
      return new Location (L1.last_line, L1.last_column,
			   L1.last_line, L1.last_column);
    }
 }

# ifndef YY_LOCATION_PRINT
#   define YY_LOCATION_PRINT(File, Loc) 				  \
       (File).print ((Loc).first_line + "." + (Loc).first_column	  \
	  	   + "-" + (Loc).last_line + "." +  (Loc).last_column)
# endif
],[#define YYLTYPE int
/* TEMPORARY CHANGE: FIXME */
#define Location int
#undef YY_LOCATION_PRINT
])[
#endif

static YYLTYPE YYLTYPE_INIT;

/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG ]b4_debug_flag[
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE ]b4_error_verbose_flag[
#endif

/* Copy the second part of user declarations.  */
]b4_post_prologue

/* Line __line__ of yacc.java.  */
b4_syncline([@oline@], [@ofile@])[

#define yysigned_char short

/* YYFINAL -- State number of the termination state. */
#define YYFINAL  ]b4_final_state_number[
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   ]b4_last[

/* YYNTOKENS -- Number of terminals. */
#define YYNTOKENS  ]b4_tokens_number[
/* YYNNTS -- Number of nonterminals. */
#define YYNNTS  ]b4_nterms_number[
/* YYNRULES -- Number of rules. */
#define YYNRULES  ]b4_rules_number[
/* YYNRULES -- Number of states. */
#define YYNSTATES  ]b4_states_number[

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  ]b4_undef_token_number[
#define YYMAXUTOK   ]b4_user_token_number_max[

#define YYTRANSLATE(YYX) 						\
  ((YYX) >= 0 && (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static final ]b4_int_type_for([b4_translate])[ yytranslate[] =
{
  ]b4_translate[
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static final ]b4_int_type_for([b4_prhs])[ yyprhs[] =
{
  ]b4_prhs[
};

/* YYRHS -- A `-1'-separated list of the rules' RHS. */
static final ]b4_int_type_for([b4_rhs])[ yyrhs[] =
{
  ]b4_rhs[
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static final ]b4_int_type_for([b4_rline])[ yyrline[] =
{
  ]b4_rline[
};
#endif

static final int YY_NUM_TERMINALS = YYNTOKENS;

static String yytname (int i) {
   if (i == yytname.length-1) 
     return null;
   else 
     return (String) yytname[i];
}

/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals. */
static final Object yytname[] =
{
  ]b4_tname[
};

/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static final int[] yytoknum =
{
  ]b4_toknum[
};

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static final ]b4_int_type_for([b4_r1])[ yyr1[] =
{
  ]b4_r1[
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static final ]b4_int_type_for([b4_r2])[ yyr2[] =
{
  ]b4_r2[
};

/* YYDEFACT[STATE-NAME] -- Default rule to reduce with in state
   STATE-NUM when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static final ]b4_int_type_for([b4_defact])[ yydefact[] =
{
  ]b4_defact[
};

/* YYDEFGOTO[NTERM-NUM]. */
static final ]b4_int_type_for([b4_defgoto])[ yydefgoto[] =
{
  ]b4_defgoto[
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF ]b4_pact_ninf[
static final ]b4_int_type_for([b4_pact])[ yypact[] =
{
  ]b4_pact[
};

/* YYPGOTO[NTERM-NUM].  */
static final ]b4_int_type_for([b4_pgoto])[ yypgoto[] =
{
  ]b4_pgoto[
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If zero, do what YYDEFACT says.
   If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF ]b4_table_ninf[
static final ]b4_int_type_for([b4_table])[ yytable[] =
{
  ]b4_table[
};

static final ]b4_int_type_for([b4_check])[ yycheck[] =
{
  ]b4_check[
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static final ]b4_int_type_for([b4_stos])[ yystos[] =
{
  ]b4_stos[
};

#undef YYSIZE_T
#define YYSIZE_T int

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto(yyacceptlab)
#define YYABORT		goto(yyabortlab)
#define YYERROR		goto(yyerrorlab)


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */

#define YYFAIL		goto(yyerrlab)

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yytoken = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto(yybackup);						\
    }								\
  else								\
    { 								\
      yyerror (yylloc, "syntax error: cannot back up");\
      YYERROR;							\
    }								\
while (false)


#define YYTERROR	1
#define YYERRCODE	256


#define YYRHSLOC(Rhs, K) ((Rhs)[K])

#ifndef YYLLOC_DEFAULT
]b4_locations_if([
/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[BASE+1] to RHS[BASE+N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

# define YYLLOC_DEFAULT(Current, Rhs, Base, N)			     \
  do {								     \
   if ((N) != 0)						     \
     Current = YYLTYPE.location_range (Current,			     \
                                       YYRHSLOC (Rhs, (Base)+1),     \
                                       YYRHSLOC (Rhs, (Base)+(N)));  \
   else								     \
     Current = YYLTYPE.location_range (Current,			     \
                                       YYRHSLOC (Rhs, Base));	     \
  } while (false)
],[#define YYLLOC_DEFAULT(Current, Rhs, Base, N)
])dnl
[
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYPRINTF
#  define YYPRINTF System.err.print
# endif

static private final String yyendl 
    = System.getProperty ("line.separator", "\n");

# define YYDPRINTF(Args)					      \
do {								      \
  if (yydebug != 0)						      \
    YYPRINTF Args;						      \
} while (false)

# define YY_SYMBOL_PRINT(Title, Type, Value, Location)		      \
do {								      \
  if (yydebug != 0)						      \
    {								      \
      YYPRINTF (Title + " ");					      \
      yysymprint (Type, Value, Location);			      \
      YYPRINTF (yyendl);					      \
    }								      \
} while (false)

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

private void yy_stack_print (int[] stack, int bottom, int top)
{
  YYPRINTF ("Stack now");
  for (/* Nothing. */; bottom <= top; bottom += 1)
    YYPRINTF (" " + stack[bottom]);
  YYPRINTF (yyendl);
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug != 0)							\
    yy_stack_print (yyssa, (Bottom), (Top));			\
} while (false)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

private void yy_reduce_print (int yyrule)
{
  int yyi;
  int yylno = yyrline[yyrule];
  YYPRINTF ("Reducing stack by rule " + (yyrule - 1) 
	     + " (line " + yylno + "), ");
  /* Print the symbols being reduced, and their result.  */
  for (yyi = yyprhs[yyrule]; 0 <= yyrhs[yyi]; yyi += 1)
    YYPRINTF (yytname [yyrhs[yyi]] + " ");
  YYPRINTF ("-> " + yytname [yyr1[yyrule]] + yyendl);
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug != 0)				\
    yy_reduce_print (Rule);		\
} while (false)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH ]b4_stack_depth_init[
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   SIZE_MAX < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH ]b4_stack_depth_max[
#endif





#if YYDEBUG
/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

private void yysymprint (int yytype, YYSTYPE yyvaluep, YYLTYPE yylocationp)
{
  if (yytype < YYNTOKENS)
    YYPRINTF ("token " + yytname[yytype]);
  else
    YYPRINTF ("nterm " + yytname[yytype]);
#if defined(YY_LOCATION_PRINT) || defined(YYPRINT)
  YYPRINTF (" (");
# ifdef YY_LOCATION_PRINT
  YY_LOCATION_PRINT (System.err, yylocationp);
  YYPRINTF (": ");
# endif
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (System.err, yytoknum[yytype], yyvaluep);
# endif
  // FIXME: Don't have symbol printers yet.
  YYPRINTF (")");
#endif
}
#endif /* ! YYDEBUG */
]


/*----------.
| parse.  |
`----------*/

#define goto(LABEL) do { pc = LABEL; continue Loop; } while (false)

  private static final int 
    yyabortlab = 1,
    yyacceptlab = 2,
    yybackup = 3,
    yydefault = 4,
    yyerrlab = 5,
    yyerrlab1 = 6,
    yyerrorlab = 7,
    yynewstate = 8,
    yyoverflowlab = 9,
    yyreduce = 10,
    yyreturn = 11,
    yysetstate = 12;

  /* The semantic value of the look-ahead symbol.  */
  YY_API_ACCESS YYSTYPE yylval;

  /* Location data for the look-ahead symbol.  */
  YY_API_ACCESS YYLTYPE yylloc;

YY_API_ACCESS %PARSERDECL%
{[
  /* The look-ahead symbol.  */
  int yychar;

  /* Number of syntax errors so far.  */
  int yynerrs;

  int yystate;
  int yyn;
  int yyresult;
  /* Number of tokens to shift before error messages enabled.  */
  int yyerrstatus;
  /* Look-ahead token as an internal (translated) token number.  */
  int yytoken = 0;

  /* Three stacks and their tools:
     `yyss': related to states,
     `yyvs': related to semantic values,
     `yyls': related to locations.

     Refer to the stacks thru separate pointers, to allow yyoverflow
     to reallocate them elsewhere.  */

  /* The state stack.  */
  int yyssa[] = new int [YYINITDEPTH];
  int yyss = 0;
  int yyssp;

  /* The semantic value stack.  */
  YYSTYPE yyvsa[] = new YYSTYPE[YYINITDEPTH];
  int yyvs = 0;
  int yyvsp;

  /* The location stack.  */
  YYLTYPE yylsa[] = new YYLTYPE[YYINITDEPTH];
  int yyls = 0;
  int yylsp;
  /* The locations where the error started and ended. */
  YYLTYPE yyerror_range[] = new YYLTYPE[2];

#define YYPOPSTACK yyvsp--; yyssp--; yylsp--

  YYSIZE_T yystacksize = YYINITDEPTH;

  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;
  YYLTYPE yyloc;

  /* When reducing, the number of symbols on the RHS of the reduced
     rule.  */
  int yylen;

  YYDPRINTF (( "Starting parse" + yyendl));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss;
  yyvsp = yyvs;
  yylsp = yyls;
  yyloc = YYLTYPE_INIT;

  yylsa[yylsp] = yyloc;

  /* Artificial initializations to keep Java happy */
  yyn = 0;
  yylen = 0;
  yyresult = 0;

  /* pc is used to hold a goto label (or FSA state, if you prefer). */
  int pc;
  pc = yysetstate;
Loop:
  while (true) {
    switch (pc) {

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 case yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed. so pushing a state here evens the stacks.
     */
  yyssp++;

 case yysetstate:
  yyssa[yyssp] = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto(yyoverflowlab);
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

#  define RELOCATE(Type, Stack)					     \
      {  								     \
	Type[] newStack = new Type[yystacksize];			     \
	System.arraycopy (Stack ## a, 0, newStack, 0, Stack ## a.length);    \
	Stack ## a = newStack;						     \
      }
      RELOCATE(int, yyss);
      RELOCATE(YYSTYPE, yyvs);
      RELOCATE(YYLTYPE, yyls); 
#  undef RELOCATE

      YYDPRINTF (( "Stack size increased to " + yystacksize + yyendl));

    }

  YYDPRINTF (( "Entering state " + yystate + yyendl));

  goto(yybackup);

/*-----------.
| yybackup.  |
`-----------*/
case yybackup:

/* Do appropriate processing given the current state.  */
/* Read a look-ahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to look-ahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYPACT_NINF)
    goto(yydefault);

  /* Not known => get a look-ahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid look-ahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF (( "Reading a token: "));
      yychar = yylex (); 
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF (( "Now at end of input." + yyendl));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, yylval, yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto(yydefault);
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yyn == 0 || yyn == YYTABLE_NINF)
	goto(yyerrlab);
      yyn = -yyn;
      goto(yyreduce);
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the look-ahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, yylval, yylloc);

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  yyvsa[++yyvsp] = yylval;
  yylsa[++yylsp] = yylloc;

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus != 0)
    yyerrstatus--;

  yystate = yyn;
  goto(yynewstate);


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
case yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto(yyerrlab);
  goto(yyreduce);


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
case yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsa[yyvsp+1-yylen];

  /* Default location. */
  YYLLOC_DEFAULT (yyloc, yylsa, yylsp - yylen, yylen);
  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    ]{
      b4_actions
    }

/* Line __line__ of yacc.java.  */
b4_syncline([@oline@], [@ofile@])

[  yyvsp -= yylen;
  yyssp -= yylen;
  yylsp -= yylen;

  YY_STACK_PRINT (yyss, yyssp);

  yyvsa[++yyvsp] = yyval;
  yylsa[++yylsp] = yyloc;

  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + yyssa[yyssp];
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == yyssa[yyssp])
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto(yynewstate);


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
case yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (yyerrstatus == 0)
    {
      ++yynerrs;
#if YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (YYPACT_NINF < yyn && yyn < YYLAST)
	{
	  int yytype = YYTRANSLATE (yychar);
	  String yyprefix;
	  String yymsg;
	  int yyx;

	  /* Start YYX at -YYN if negative to avoid negative indexes in
	     YYCHECK.  */
	  int yyxbegin = yyn < 0 ? -yyn : 0;

	  /* Stay within bounds of both yycheck and yytname.  */
	  int yychecklim = YYLAST - yyn;
	  int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
	  int yycount = 0;

	  yyprefix = ", expecting ";
	  for (yyx = yyxbegin; yyx < yyxend; ++yyx)
	    if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
	      {
		yycount += 1;
		if (yycount == 5)
		  break;
	      }
	  yymsg = "";
          yymsg += "syntax error, unexpected " + yytname[yytype];
	  if (yycount < 5)
	      {
		  yyprefix = ", expecting ";
		  for (yyx = yyxbegin; yyx < yyxend; ++yyx)
		    if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
		      {
			yymsg += yyprefix + yytname[yyx];
			yyprefix = " or ";
		      }
	      }
	   yyerror (yylloc, yymsg);
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror (yylloc, "syntax error");
    }

  yyerror_range[0] = yylloc;

  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse look-ahead token after an
	 error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* If at end of input, pop the error token,
	     then the rest of the stack, then return failure.  */
	  if (yychar == YYEOF)
	     for (;;)
	       {
                 yyerror_range[0] = yylsa[yylsp];
		 YYPOPSTACK;
		 if (yyssp == yyss)
		   YYABORT;
	       }
        }
      else
	{
	  yychar = YYEMPTY;
	}
    }

  /* Else will try to reuse look-ahead token after shifting the error
     token.  */
  goto(yyerrlab1);


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
case yyerrorlab:

  yyerror_range[0] = yylsa[yylsp+1-yylen];
  yylsp -= yylen;
  yyvsp -= yylen;
  yyssp -= yylen;
  yystate = yyssa[yyssp];
  goto(yyerrlab1);


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
case yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (yyn != YYPACT_NINF)
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;

      yyerror_range[0] = yylsa[yylsp];
      YYPOPSTACK;
      yystate = yyssa[yyssp];
      YY_STACK_PRINT (yyss, yyssp);
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  yyvsa[++yyvsp] = yylval;
  yyerror_range[1] = yylloc;
  /* Using YYLLOC is tempting, but would change the location of
     the look-ahead.  YYLOC is available though. */
  YYLLOC_DEFAULT (yyloc, yyerror_range, -1, 2);
  yylsa[++yylsp] = yyloc;

  /* Shift the error token. */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsa[yyvsp], yylsa[yylsp]);

  yystate = yyn;
  goto(yynewstate);


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
case yyacceptlab:
  yyresult = 0;
  goto(yyreturn);

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
case yyabortlab:
  yychar = YYEMPTY;
  yyresult = 1;
  goto(yyreturn);

#ifndef yyoverflow
/*----------------------------------------------.
| yyoverflowlab -- parser overflow comes here.  |
`----------------------------------------------*/
case yyoverflowlab:
  yyerror (yylloc, "parser stack overflow");
  yyresult = 2;
  /* Fall through.  */
#endif

case yyreturn:
  return yyresult;
}
}

]}

b4_epilogue

}

